***********ANALYSIS OF UIS DATA**************

set more off
set more off
cd "/Users/karawa/Documents/0_BD2022/Vityakorn2022/Med_Dpt_KKU_WkShop/R_STATA_July_2022/SurvivalAnalysis/data/"
*Please change in the bracket to be your working directory
clear all
use uis

*5.2.1 Age at Enrollment
table  treat, c(n age mean age sd age)
table  treat, c(n age median age min age max age)

*5.2.2 Beck Depression Score
table  treat, c(n  becktota mean  becktota sd  becktota)
table  treat, c(n becktota median  becktota min  becktota max  becktota)

*5.2.3 Heroin/Cocaine Use During 3 Months Prior to Admission
tab  hercoc treat, col

*5.2.4 History of IV Drug Use
tab   ivhx treat, col

*5.2.5 Number of Prior Drug Treatments
table  treat, c(n   ndrugtx mean   ndrugtx sd   ndrugtx)
table  treat, c(n  ndrugtx median   ndrugtx min   ndrugtx max  ndrugtx)

*5.2.6 Subject's Race
tab  race treat, col

*5.2.7 Treatment Site
tab  site treat, col

*5.2.8 Length of Stay in Treatment (Admission Date to Exit Date)
table  treat, c(n  los mean  los sd  los)
table  treat, c(n  los median  los min  los max los)
table  treat, c(n los median los min los max los)

*5.3 ӡ Set ͡ Survival analysis
stset  time, failure(censor)

*5.4 óٻẺ֡
stdes

*5.5 ó Overall survival experience
*Summarizing survival experience
stsum, by( treat)

*Estimating the confidence intervals of median time

stsum, by( treat)

*Incidence density and the 95% confidence intervals

strate  treat


*Controlling for confounders using stratified analysis

stmh  treat, by(site)

*Controlling for variation of rate on a time scale

stmc  treat
sts g, by(treat)

*5.6 ӡҧҺ (Bivariate analysis)
*5.6.1 Age at Enrollment
su age, de
gen agegg = .
replace agegg = 1 if age <= 27 &  age ~= . 
replace agegg = 2 if age > 27 & age <= 32 & age ~= .
replace agegg = 3 if age > 32 & age <= 37 & age ~= .
replace agegg = 4 if age > 37 & age ~= .

tab agegg
xtile ageg =  age, nq(4)

tab ageg
tab  ageg treat, col

stsum, by(ageg)

sts g, by(ageg)

xi:stcox i.ageg, nolog noshow

stcox age, nolog noshow
stcox age, nohr nolog noshow

gen age5 = age/5
stcox age5, nolog noshow
*5.6.2 Beck Depression Score


su  becktota, de
xtile  beckg =   becktota, nq(4)


tab  beckg treat, col
stsum, by(beckg)
 sts g, by(beckg)
 xi:stcox  i.beckg
 xi:stcox  i.beckg, nolog noshow
 stcox   becktota, nolog noshow
 gen  beck10 =  becktota/10
 stcox beck10, nolog noshow

 tab  hercoc  treat, col
 stsum, by( hercoc)
 sts g, by( hercoc)
 xi:stcox  i.hercoc, nolog noshow
 tab  ivhx  treat, col
 stsum, by( ivhx)
 sts g, by( ivhx)
 xi:stcox  i.ivhx, nolog noshow
*5.6.5 Number of Prior Drug Treatments

 su  ndrugtx, de
 xtile  ndrugtxg   =   ndrugtx, nq(4)


 tab  ndrugtxg treat, col
 stsum, by( ndrugtxg)
 sts g, by( ndrugtxg)
 xi:stcox  i.ndrugtxg, nolog noshow
 stcox  ndrugtx, nolog noshow
 gen ndrug5 =  ndrugtx / 5

stcox ndrug5, nolog noshow
*5.6.6 Subject's Race

 tab  race treat, col
 stsum, by(race)
 sts g, by(race)
 stcox  race, nolog noshow
*5.6.7 Assignment Treatment Site



 tab  site treat, col
 stsum, by(site)
 sts g, by(site)
 stcox  site, nolog noshow
*5.6.8 Treatment assignment

 tab treat
 stsum, by(treat)
 sts g, by(treat)
 stcox  treat, nolog noshow

*5.6.9 	 Length of Stay in Treatment (Admission Date to Exit Date) 
*5.7 ҧ (Model fitting)
*5.7.1 The initial multivariable model
xi:stcox  age becktota ndrugtx i.hercoc i.ivhx race treat  site, nolog noshow nohr

 estimate store A

*5.7.2 ͡ẺШ (Purposeful selection)  Backward elimination
 xi:stcox  age becktota ndrugtx i.ivhx race treat  site, nolog noshow nohr
 lrtest A
 estimate store B
 tab ivhx

 gen ivhx01 = .
replace ivhx01 = 0 if ivhx <= 3 & ivhx ~= .
replace ivhx01 = 1 if ivhx == 3  & ivhx ~= .

 tab ivhx01
 xi:stcox  age becktota ndrugtx ivhx01 race treat  site, nolog noshow nohr
 lrtest B

*5.7.3 Scale selection óյ Continuous

*5.7.3.1 Ը Dummy variables
 xi:stcox i.ageg  becktota ndrugtx ivhx01 race treat  site, nolog noshow nohr
 su age, de
 xi:stcox age  i.beckg ndrugtx ivhx01 race treat  site, nolog noshow nohr
 su  becktota, de
 xi:stcox age  becktota i.ndrugtxg ivhx01 race treat  site, nolog noshow nohr
 su   ndrugtx, de

*************USE DATA SET FROM WORKBOOK P.73
 *gr  coef  midpiont if  x == 1, c(l)
 *gr  coef  midpiont if  x == 2, c(l)
 *gr  coef  midpiont if  x == 3, c(l)


*5.7.3.2 Ը Fractional polynomial
fracpoly cox time age becktota ndrugtx ivhx01 race treat  site, dead(censor)compare

fracpoly cox time becktota age ndrugtx ivhx01 race treat  site, dead(censor)compare

fracpoly cox time  ndrugtx becktota age ivhx01 race treat  site, dead(censor)compare

gen ndrugfp1 =  ((ndrugtx + 1)/10)^(-1)
gen ndrugfp2 =  ((ndrugtx + 1)/10)^(-1) * ln((ndrugtx + 1)/10)

*5.7.4 ӷء÷١Ѵ͡仡Ѻ Model ա
 xi:stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat site i.hercoc, nolog noshow nohr
* lrtest A
* estimate store A


* stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site, nolog noshow nohr
* lrtest A

* skip due to high missing data

*5.7.5 þԨó Interaction effect

gen ageXbeck = age* becktota
quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site ageXbeck

estimate store B


quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

lrtest B

gen ageXndr1 =  age* ndrugfp1
 gen ageXndr2 =  age* ndrugfp2
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  ageXndr1 ageXndr2

estimate store C

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest C
 gen ageXivhx =  age*ivhx01
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  ageXivhx

 estimate store D

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest D
 gen ageXrace = age*race
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site ageXrace

 estimate store E

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site
 lrtest E
 gen ageXtrea = age *  treat
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site ageXtrea

 estimate store F

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest F

 gen ageXsite = age * site
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site ageXsite

 estimate store G


quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest G

 gen becXndr1 =  becktota *  ndrugfp1
 gen becXndr2 =  becktota *  ndrugfp2
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  becXndr1 becXndr2

estimate store H

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest H

 gen becXivhx =  becktota *  ivhx01
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  becXivhx

 estimate store I

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

 lrtest I
 gen becXrace =  becktota *  race
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  becXrace

 estimate store J

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

 lrtest J
 gen becXtrea =  becktota * treat
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  becXtrea

 estimate store B0

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest B0
 gen becXsite =  becktota * site
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  becXsite

 estimate store B1

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest B1
 gen nd1Xivhx =   ndrugfp1*ivhx01
 gen nd2Xivhx =   ndrugfp2*ivhx01
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  nd1Xivhx nd2Xivhx

 estimate store B2

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest B2
 gen nd1Xrace =   ndrugfp1*race
 gen nd2Xrace =   ndrugfp2*race
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  nd1Xrace nd2Xrace

 estimate store B3

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest B3
 gen nd1Xtrea =   ndrugfp1*treat
 gen nd2Xtrea =   ndrugfp2*treat
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  nd1Xtrea nd2Xtrea

 estimate store B4

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site

 lrtest B4
 gen nd1Xsite =   ndrugfp1*site
 gen nd2Xsite =   ndrugfp2*site
quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site  nd2Xsite
estimate store B5
quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site
lrtest B5
gen ivhXrace =   ivhx01*race
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 
quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site ivhXrace

 estimate store B6

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

lrtest B6
gen ivhXtrea =   ivhx01*treat

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site ivhXtrea

estimate store B7

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

lrtest B7
gen ivhXsite =   ivhx01*site

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site ivhXsite

 estimate store B8

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

lrtest B8
gen racXtrea =   race * treat

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site racXtrea

 estimate store B9

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

lrtest B9
gen racXsite =   race * site

 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site racXsite

estimate store C0

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

 lrtest C0
gen treXsite =   treat * site

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site treXsite

estimate store C1

quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site 

 lrtest C1
 stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site racXsite ageXsite, nohr nolog
estimate store A
stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site racXsite, nohr nolog
 lrtest A
*5.7.6 Assessment of model adequacy
*5.7.6.1 Assessing the proportional hazard assumption
*5.7.6.1.1 ٨ҡҿ
 stphplot, by(treat)
stcoxkm, by( treat)

*5.7.6.1.2 ͺ Proportional hazard assumption

stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat site racXsite, scaledsch(sca*) schoenfeld(sch*) nolog
stphtest, rank detail
stphplot, by(treat)
*5.7.6.2 Identification of influential and poorly fit subjects
stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat  site racXsite, mgale(mg)
 quietly predict double dev, deviance

 lowess dev time


*5.7.6.3 Overall goodness-of-fit test

 stcoxgof
 stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat, strata(site) nolog
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat, strata(site) nolog mgale(mga)


 *predict csa, csnell
 *stset csa, failure(censor)
 *sts generate kma = s

 *gen double Ha = -ln(km)
 *graph Ha csa csa, c(ll) s(..) lowessb ylab
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat, strata(site) mgale(Z)


drop sch*
drop sca*
 stcoxgof
 quietly stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat, strata(site) nolog mgale(mgal) scaledsch(sca*) schoenfeld(sch*)

 stphtest, rank detail

 drop age5
 gen age5 = age/5

 gen  beck5 =  becktota/5

 stcox treat ivhx01 race ndrugfp1 ndrugfp2 age5 beck5, strata(site) noshow nolog

quietly stcox treat ivhx01 race ndrugfp1 ndrugfp2 age becktota, strata(site) 

 estimate store A

*äӹǳҤ p-value ҡ Partial likelihood ratio test 觵仹


 quietly stcox ivhx01 race ndrugfp1 ndrugfp2 age becktota, strata(site) 

 lrtest A, force

 quietly stcox treat race ndrugfp1 ndrugfp2 age becktota, strata(site) 

 lrtest A, force

 quietly stcox treat ivhx01 ndrugfp1 ndrugfp2 age becktota, strata(site) 

 lrtest A, force
 quietly stcox treat ivhx01 race ndrugfp2 age becktota, strata(site) 

 lrtest A, force
 quietly stcox treat ivhx01 race ndrugfp1 age becktota, strata(site) 

 lrtest A, force
 quietly stcox treat ivhx01 race ndrugfp1 ndrugfp2 becktota, strata(site) 

 lrtest A, force

 quietly stcox treat ivhx01 race ndrugfp1 ndrugfp2 age, strata(site) 

 lrtest A, force

 su  ndrugtx, de
 gen ndrugmd = .
 replace ndrugmd = .

 replace ndrugmd = 0 if  ndrugtx <=3 &  ndrugtx ~= .

 replace ndrugmd = 1 if  ndrugtx > 3 &  ndrugtx ~= .

 drop sch*
 drop sca*
 
 tab ndrugmd
 stcox ndrugmd, nolog noshow
 stcox age becktota ndrugfp1 ndrugfp2 ivhx01 race treat, strata(site) nolog noshow nohr
 stcox age becktota ndrugmd ivhx01 race treat, strata(site) nolog noshow nohr
 stcox age becktota ndrugmd ivhx01 race treat, strata(site) nolog noshow nohr
 stcox age becktota ndrugmd ivhx01 race treat, strata(site) scaledsch(sca*) schoenfeld(sch*) nolog
 stphtest, rank detail
 drop dev
 quietly predict double dev, deviance

 lowess dev time

 *predict cs, csnell
 *stset cs, failure(censor)
 *sts generate km = s

 *gen double H = -ln(km)
 *graph H cs cs, c(ll) s(..) lowessb ylab
 quietly stcox age becktota ndrugmd ivhx01 race treat, strata(site) mgale(X)

 stcoxgof
 stcox treat ivhx01 race ndrugmd age5 beck5, strata(site) noshow nolog

 quietly stcox treat ivhx01 race ndrugmd age becktota, strata(site) 

 estimate store A

 quietly stcox ivhx01 race ndrugmd age becktota, strata(site) 


 lrtest A, force
 quietly stcox treat race ndrugmd age becktota, strata(site) 

 lrtest A, force

 quietly stcox treat ivhx01 ndrugmd age becktota, strata(site) 

 lrtest A, force

 quietly stcox treat ivhx01 race age becktota, strata(site) 

 lrtest A, force
 quietly stcox treat ivhx01 race ndrugmd  becktota, strata(site) 

 lrtest A, force

 quietly stcox treat ivhx01 race ndrugmd age, strata(site) 

 lrtest A, force

*5.8 ҧҿͧ Predicted survival curves ҡ Cox Proportional Hazards model
stcoxplt, xvar(treat) adjust(ivhx01 race ndrugmd age5 beck5 site) c(JJ)

*5.9 ǹ

*5.9.1  Prediction of survival

 stcox treat site, noshow nolog nohr
 quietly stcox treat site, basech(H0)

 sort _t

 list id treat site _t H0
 quietly stcox treat site, basesurv(S0)
 sort _t

 list id treat site _t H0 S0
 predict XB, xb
 sort _t
 list id treat site _t H0 S0 XB
 
*5.9.2 ҧѺ Fit Model  Parametric Model
*5.9.2.1 Exponential regression

streg treat site, dist(exp)

*5.9.2.2 Weibull regression

streg treat site, dist(weibull)

*5.9.2.3 Gompetz regression

streg treat site, dist(gompertz)

*5.9.2.4 Gamma regression

streg treat site, dist(gamma)

*5.9.2.5 Log normal regression

streg treat site, dist(lognormal)

*5.9.2.6 Log logistic regression

streg treat site, dist(llogistic)




